<?php
class installerDps {
	static public $update_to_version_method = '';
	static private $_firstTimeActivated = false;
	static public function init() {
		global $wpdb;
		$wpPrefix = $wpdb->prefix; /* add to 0.0.3 Versiom */
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		$current_version = get_option($wpPrefix. DPS_DB_PREF. 'db_version', 0);
		if(!$current_version)
			self::$_firstTimeActivated = true;
		/**
		 * modules
		 */
		if (!dbDps::exist("dps_modules")) {
			$charset_collate = $wpdb->get_charset_collate();
			$table_name = $wpdb->prefix . 'dps_modules';
			$sql = "CREATE TABLE $table_name (
				`id` smallint(3) NOT NULL AUTO_INCREMENT,
			  `code` varchar(32) NOT NULL,
			  `active` tinyint(1) NOT NULL DEFAULT '0',
			  `type_id` tinyint(1) NOT NULL DEFAULT '0',
			  `label` varchar(64) DEFAULT NULL,
			  `ex_plug_dir` varchar(255) DEFAULT NULL,
			  PRIMARY KEY (`id`),
			  UNIQUE INDEX `code` (`code`)
			) $charset_collate";
			require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
			dbDelta($sql);

			$tableName = $wpdb->prefix . "dps_modules";
			$wpdb->insert($tableName, array(
					'code' => 'adminmenu',
					'active' => 1,
					'type_id' => 1,
					'label' => 'Admin Menu',
			));
			$wpdb->insert($tableName, array(
					'code' => 'options',
					'active' => 1,
					'type_id' => 1,
					'label' => 'Options',
			));
			$wpdb->insert($tableName, array(
					'code' => 'user',
					'active' => 1,
					'type_id' => 1,
					'label' => 'Users',
			));
			$wpdb->insert($tableName, array(
					'code' => 'pages',
					'active' => 1,
					'type_id' => 1,
					'label' => 'Pages',
			));
			$wpdb->insert($tableName, array(
					'code' => 'templates',
					'active' => 1,
					'type_id' => 1,
					'label' => 'templates',
			));
			$wpdb->insert($tableName, array(
					'code' => 'supsystic_promo',
					'active' => 1,
					'type_id' => 1,
					'label' => 'supsystic_promo',
			));
			$wpdb->insert($tableName, array(
					'code' => 'dps',
					'active' => 1,
					'type_id' => 1,
					'label' => 'digital_publications_supsystic',
			));
			$wpdb->insert($tableName, array(
					'code' => 'book',
					'active' => 1,
					'type_id' => 1,
					'label' => 'book',
			));
			$wpdb->insert($tableName, array(
					'code' => 'page',
					'active' => 1,
					'type_id' => 1,
					'label' => 'page',
			));
			$wpdb->insert($tableName, array(
					'code' => 'pages_import',
					'active' => 1,
					'type_id' => 1,
					'label' => 'pages_import',
			));
			$wpdb->insert($tableName, array(
					'code' => 'mail',
					'active' => 1,
					'type_id' => 1,
					'label' => 'mail',
			));
		}
		if(!dbDps::exist('dps_modules', 'code', 'pages_import')) {
			dbDps::query("INSERT INTO `@__modules` (id, code, active, type_id, label) VALUES
				(NULL, 'pages_import',1,1,'pages_import');");
		}
		/**
		 *  modules_type
		 */
		if(!dbDps::exist("dps_modules_type")) {
			dbDelta(dbDps::prepareQuery("CREATE TABLE IF NOT EXISTS `@__modules_type` (
			  `id` smallint(3) NOT NULL AUTO_INCREMENT,
			  `label` varchar(32) NOT NULL,
			  PRIMARY KEY (`id`)
			) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;"));

			$tableName = $wpdb->prefix . "dps_modules_type";
			$wpdb->insert($tableName, array(
					'id' => 1,
					'label' => 'system',
			));
			$wpdb->insert($tableName, array(
					'id' => 6,
					'label' => 'addons',
			));
		}
		/**
		* Plugin usage statistics
		*/
		if(!dbDps::exist("dps_usage_stat")) {
			dbDelta(dbDps::prepareQuery("CREATE TABLE `@__usage_stat` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `code` varchar(64) NOT NULL,
			  `visits` int(11) NOT NULL DEFAULT '0',
			  `spent_time` int(11) NOT NULL DEFAULT '0',
			  `modify_timestamp` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			  UNIQUE INDEX `code` (`code`),
			  PRIMARY KEY (`id`)
			) DEFAULT CHARSET=utf8"));
			$tableName = $wpdb->prefix . "dps_usage_stat";
			$wpdb->insert($tableName, array(
					'code' => 'installed',
					'visits' => 1,
			));
		}
		/**
		 *  pages sort order
		 */
		if(!dbDps::exist("dps_page_sort_order")) {
			dbDelta(dbDps::prepareQuery("CREATE TABLE IF NOT EXISTS `@__page_sort_order` (
			  `book_id` int(11) NOT NULL,
			  `page_id` int(11) NOT NULL,
			  `sort_order` int(7) NOT NULL,
			  INDEX `page_id_F1_1` (`page_id`)
			)DEFAULT CHARSET=utf8;"));
		}
		/**
		 *  pages that is images
		 */
		if(!dbDps::exist("dps_page_as_img")) {
			dbDelta(dbDps::prepareQuery("CREATE TABLE IF NOT EXISTS `@__page_as_img` (
			  `page_id` int(11) NOT NULL,
			  `attach_id` int(11) NOT NULL,
			  `img_url` VARCHAR(255) NOT NULL,
			  INDEX `page_id_F1_1` (`page_id`)
			)DEFAULT CHARSET=utf8;"));
		}
		installerDbUpdaterDps::runUpdate();
		if($current_version && !self::$_firstTimeActivated) {
			self::setUsed();
		}
		update_option($wpPrefix. DPS_DB_PREF. 'db_version', DPS_VERSION);
		add_option($wpPrefix. DPS_DB_PREF. 'db_installed', 1);
	}
	static public function setUsed() {
		update_option(DPS_DB_PREF. 'plug_was_used', 1);
	}
	static public function isUsed() {
		// No welcome page for now
		return true;
		return (int) get_option(DPS_DB_PREF. 'plug_was_used');
	}
	static public function delete() {
		global $wpdb;
		$wpPrefix = $wpdb->prefix;
		$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}dps_modules");
		$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}dps_modules_type");
		$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}dps_usage_stat");
		$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}dps_page_sort_order");
		$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}dps_page_as_img");
		delete_option($wpPrefix. DPS_DB_PREF. 'db_version');
		delete_option($wpPrefix. DPS_DB_PREF. 'db_installed');
	}
	static public function update() {
		global $wpdb;
		$wpPrefix = $wpdb->prefix; /* add to 0.0.3 Versiom */
		$currentVersion = get_option($wpPrefix. DPS_DB_PREF. 'db_version', 0);
		if(!$currentVersion || version_compare(DPS_VERSION, $currentVersion, '>')) {
			self::init();
			update_option($wpPrefix. DPS_DB_PREF. 'db_version', DPS_VERSION);
		}
	}
}
