function dpsOnAdminBgImgChange(imgUrl) {
	if(imgUrl && imgUrl != '') {
		jQuery('#dpsAdminBookBgImgPrev').show().attr('src', imgUrl);
	} else {
		jQuery('#dpsAdminBookBgImgPrev').hide();
	}
}
function dpsOnAdminPageBgImgChange(imgUrl) {
	if(imgUrl && imgUrl != '') {
		jQuery('#dpsAdminBookPageBgImgPrev').show().attr('src', imgUrl);
	} else {
		jQuery('#dpsAdminBookPageBgImgPrev').hide();
	}
}
function dpsOnAdminAudioChange(audioUrl, attachment) {
	if(audioUrl && audioUrl != '') {
		var isSoundDefault = audioUrl == dpsDefaultAudioPaging;
		jQuery('.dpsAdminBookAudioLink').show().attr('href', audioUrl).html( isSoundDefault ? toeLangDps('Default') : audioUrl );
		if(isSoundDefault) {
			jQuery('.dpsAdminBookAudioSetDefaultLink').hide();
		} else {
			jQuery('.dpsAdminBookAudioSetDefaultLink').show();
		}
	} else {
		jQuery('.dpsAdminBookAudioLink').hide();
		jQuery('.dpsAdminBookAudioSetDefaultLink').show();
	}
}
function dpsOnAdminOpacitySlideMove(event, ui) {
	toeSliderMove(event, ui);
	if(typeof(dpsLivePreviewParams) != 'undefined') {
		dpsLivePreviewParams.update({
			bg_opacity: ui.value
		});
	}
}
jQuery(document).ready(function(){
	jQuery('.dpsAdminBookAudioSetDefaultLink').click(function(){
		jQuery('[name="dps[audio_paging]"]').val( dpsDefaultAudioPaging );
		dpsOnAdminAudioChange(dpsDefaultAudioPaging);
		return false;
	});
	jQuery('.dpsAdminBookAudioNoSoundLink').change(function(){
		jQuery('[name="dps[audio_paging]"]').val('');
		dpsOnAdminAudioChange('');
		return false;
	});

	dpsHideUnusedFormFields();
	// Erlier did not work - after selection on ctrl-c it copy parent element of this span - don't know why. But now it is fine.
	jQuery('.gmpShortCodePreview span').click(function(){
		toeSelectText(jQuery(this));
	});
	// After new book creation - we need to redirect user to this book,
	// book is added as usual tag, see tags.js, via ajax, and there are no actions on clients side,
	// so we have no other chance to do this - as add global ajax success event listener
	// and check each ajax success responce, waiting for responc about book adding.
	jQuery(document).ajaxSuccess(function(event, xhr, settings) {
		try {
            var parsedStr = parseStr(dpsFixedEncodeURI(settings.data));
        } catch (err) {
            window.console && console.log('Error parsing url: ' + err.message);
            return;
        }
		var sentData = settings && settings.data  ? parsedStr : false;
		if(sentData
			&& sentData.action == 'add-tag'
			&& sentData.dps
			&& sentData.taxonomy == DPS_DATA.DPS_BOOK
			&& xhr
			&& xhr.responseXML
		) {
			var res = res = wpAjax.parseAjaxResponse( xhr.responseXML, 'ajax-response' );
			if (! res || res.errors)
				return;
			var term = res.responses[1].supplemental;
			if(term && term.term_id) {
				toeRedirect(dpsGetBookEditLink(term.term_id));
			}
		}
	});

	// Set options change handlers
	// Common options
	jQuery('#term_dps_bg_type_shell').find('input:radio').change(function(){
		if(!jQuery(this).prop('checked')) return;
		dpsAreaBgTypeOptionsVisible(jQuery(this).val());
	});
	jQuery('#term_dps_page_bg_type_shell').find('input:radio').change(function(){
		if(!jQuery(this).prop('checked')) return;
		dpsPublicationBgTypeOptionsVisible(jQuery(this).val());
	});
	jQuery('#term_dps_audio_paging_shell').find('input:radio').change(function(){
		if(!jQuery(this).prop('checked')) return;
		dpsChangeSoundBtnVisible(jQuery(this).val());
	});

	// Toolbar design options
	jQuery('#term_dps_toolbar_code_input_shell').find('input[name="dps[toolbar_preset]"]').change(function(){
		if(!jQuery(this).prop('checked')) return;
		dpsChangeToolbarPreset(jQuery(this).val());
	});
	jQuery('#term_dps_toolbar_bg_opacity_shell').find('input[name="dps[toolbar_bg_opacity]"]').change(function(){
		var tbColor = getRGBAColors(jQuery('input[name="dps[toolbar_bg_color]"]').val(), jQuery(this).val());
		dpsToolbarBgColor(tbColor);
	});
	jQuery('#term_dps_en_toolbar_shadow_shell').find('input:radio').change(function(){
		if(!jQuery(this).prop('checked')) return;
		dpsChangeToolbarShadowVisible(jQuery(this).val());
	});
	/*jQuery('#term_dps_en_toolbar_tootips_shell').find('input:radio').change(function(){
		if(!jQuery(this).attr('checked')) return;
		dpsChangeTooltipsOptionsVisible(jQuery(this).val());
	});*/

	//Toolbar buttons options
	var dpsFwBwBtnsShell = jQuery('#term_dps_en_fw_bw_btns_input_shell')
	,	dpsPgNumbFormShell = jQuery('#term_dps_en_page_nmb_field_input_shell')
	,	dpsPrintExpBtnShell = jQuery('#term_dps_en_print_export_btn_input_shell')
	,	dpsSearchBtnShell = jQuery('#term_dps_en_search_btn_input_shell')
	,	dpsFullScrBtnShell = jQuery('#term_dps_en_fullscreen_btn_input_shell')
	,	dpsZoomBtnShell = jQuery('#term_dps_en_zoom_btn_input_shell');

	dpsFwBwBtnsShell.find('input:radio').change(function(){
		dpsChangeToolbarElementsVisible('#'+ dpsFwBwBtnsShell.attr('id'));
	});
	dpsPgNumbFormShell.find('input:radio').change(function(){
		dpsChangeToolbarElementsVisible('#'+ dpsPgNumbFormShell.attr('id'));
	});
	dpsPrintExpBtnShell.find('input:radio').change(function(){
		dpsChangeToolbarElementsVisible('#'+ dpsPrintExpBtnShell.attr('id'));
	});
	dpsSearchBtnShell.find('input:radio').change(function(){
		dpsChangeToolbarElementsVisible('#'+ dpsSearchBtnShell.attr('id'));
	});
	dpsFullScrBtnShell.find('input:radio').change(function(){
		dpsChangeToolbarElementsVisible('#'+ dpsFullScrBtnShell.attr('id'));
	});
	dpsZoomBtnShell.find('input:radio').change(function(){
		dpsChangeToolbarElementsVisible('#'+ dpsZoomBtnShell.attr('id'));
	});
});
/**
 * We will hide unused fields on add and edit book form
 */
function dpsHideUnusedFormFields() {
	jQuery('#tag-slug, #parent, #tag-description, #slug, #description').each(function(){
		jQuery(this).parents('.form-field:first').hide();
	});
}
function dpsAreaBgTypeOptionsVisible(type) {
	switch(type) {
		case 'color':
			jQuery('#term_dps_bg_color_shell, #term_dps_bg_opacity_shell').show();
			jQuery('#term_dps_bg_img_shell, #term_dps_bg_img_pos_shell').hide();
			break;
		case 'img':
			jQuery('#term_dps_bg_color_shell, #term_dps_bg_opacity_shell').hide();
			jQuery('#term_dps_bg_img_shell, #term_dps_bg_img_pos_shell').show();
			break;
		default:
			jQuery('#term_dps_bg_color_shell, #term_dps_bg_opacity_shell, ' +
			'#term_dps_bg_img_shell, #term_dps_bg_img_pos_shell').hide();
			break;
	}
}
function dpsPublicationBgTypeOptionsVisible(type) {
	switch(type) {
		case 'color':
			jQuery('#term_dps_page_bg_color_shell, #term_dps_page_bg_opacity_shell').show();
			jQuery('#term_dps_page_bg_img_shell, #term_dps_page_bg_img_pos_shell').hide();
			break;
		case 'img':
			jQuery('#term_dps_page_bg_color_shell, #term_dps_page_bg_opacity_shell').hide();
			jQuery('#term_dps_page_bg_img_shell, #term_dps_page_bg_img_pos_shell').show();
			break;
		default:
			jQuery('#term_dps_page_bg_color_shell, #term_dps_page_bg_opacity_shell, ' +
			'#term_dps_page_bg_img_shell, #term_dps_page_bg_img_pos_shell').hide();
			break;
	}
}
function dpsChangeSoundBtnVisible(val) {
	if(val)
		jQuery('#term_dps_audio_paging_input_shell').show(300);
	else
		jQuery('#term_dps_audio_paging_input_shell').hide(300);
}
function dpsSwitchPresetClass(preset) {
	var toolbarShell = jQuery('.dpsTdShell_simple');
	switch(preset) {
		case 'colorset':
			if(toolbarShell.hasClass('borderset'))
				toolbarShell.removeClass('borderset');
			toolbarShell.addClass('colorset');
			break;
		case 'borderset':
			if(toolbarShell.hasClass('colorset'))
				toolbarShell.removeClass('colorset');
			toolbarShell.addClass('borderset');
			break;
	}
}
function dpsChangeToolbarPreset(preset) {
	var bgColor = getRGBAColors(dpsBookPresets[preset]['bg_color'], dpsBookPresets[preset]['bg_opacity'])
	,	bgOpacity = dpsBookPresets[preset]['bg_opacity']
	,	btnsColor = dpsBookPresets[preset]['color']
	,	btnsActColor = dpsBookPresets[preset]['hover'];

	dpsSwitchPresetClass(preset);
	dpsToolbarBgColor(bgColor, preset);
	dpsToolbarBgOpacity(bgOpacity);
	dpsToolbarBtnsColor(btnsColor, preset);
	dpsToolbarBtnsActiveColor(btnsActColor);
	jQuery("#term_dps_toolbar_bg_color").wpColorPicker('color', dpsBookPresets[preset]['bg_color']);
	jQuery("#term_dps_toolbar_btns_color").wpColorPicker('color', btnsColor);
	jQuery("#term_dps_toolbar_btns_active_color").wpColorPicker('color', btnsActColor);
}
function dpsToolbarBgColor(val, preset) {
	jQuery('.btnTbMain').css('background-color', val);
	if(preset == 'colorset') {
		var color = getRGBAColors('#ffffff', '0');
		dpsToolbarBorderColor('1px solid '+ color);
	}
}
function dpsToolbarBorderColor(val) {
	jQuery('.dpsTdShell_simple .btnTbMain').css('border', val);
}
function dpsToolbarBgOpacity(val) {
	var persent = val*100;
	jQuery('#toeSliderDisplay_term_dps_toolbar_bg_opacity').html(val);
	jQuery('#toeSliderInput_term_dps_toolbar_bg_opacity').val(val).change();
	jQuery('#term_dps_toolbar_bg_opacity span').css('left', persent+ '%');
}
function dpsToolbarBtnsColor(val, preset) {
	jQuery('.dpsTdShell_simple .dpsTbBtn i.fa').css('color', val);
	jQuery('.dpsTdShell_simple .dpsTbPageNumTxt').css('border', '1px solid '+ val);
	if(preset == 'borderset')
		dpsToolbarBorderColor('1px solid '+ val);
	//jQuery('.dpsTdShell_night .dpsTbBtn i.fa').css('color', val);
	/*jQuery('.dpsTdShell_night .dpsTbBtn i.fa').css({
		background: val
		,	webkitBackgroundClip: 'text'
		,	webkitTextFillColor: 'transparent'
	});*/
}
function dpsToolbarBtnsActiveColor(val) {
	jQuery('#toolbarShell').prepend('<style class="activeButtonColor" type="text/css">' +
		'#toolbarShell .dpsTdShell_simple.colorset i.fa:hover {' +
			'color: '+ val +' !important; }' +
		'#toolbarShell .dpsTdShell_simple.borderset .btnContainer:hover {' +
			'background-color: '+ val +' !important; }' +
		/*'#toolbarShell .dpsTdShell_night i.fa:hover {' +
			'text-shadow: 0px 0px 10px '+ val +' !important; '+
			'text-shadow: 5px 1px 5px '+ val +' !important; '+*/
	'</style>');
}
function getRGBAColors(color, opacity) {
	opacity = typeof(opacity) != 'undefined' ? parseFloat(opacity) : 1;
	var rgbaColor = convertHexToRGBA(color);
	return 'rgba('+ rgbaColor +', '+ opacity +')';
};
function convertHexToRGBA(hexColor) {
	var cutHex = hexColor.charAt(0)=="#" ? hexColor.substring(1,7) : hexColor
	,	r = parseInt(cutHex.substring(0,2), 16)
	,	g = parseInt(cutHex.substring(2,4), 16)
	,	b = parseInt(cutHex.substring(4,6), 16);
	return r+ ', '+ g+ ', '+ b;
};
function dpsChangeToolbarElementsVisible(buttonShell) {
	var params = ''
	,	noParent = false;
	switch(buttonShell) {
		case '#term_dps_en_fw_bw_btns_input_shell':
			params = '.dpsTbBtnFirst, .dpsTbBtnPrev, .dpsTbBtnNext, .dpsTbBtnLast';
			break;
		case '#term_dps_en_page_nmb_field_input_shell':
			params = '.dpsTbPageNumTxt';
			noParent = true;
			break;
		case '#term_dps_en_print_export_btn_input_shell':
			params = '.dpsTbBtnExport';
			break;
		case '#term_dps_en_search_btn_input_shell':
			params = '.dpsTbBtnSearch';
			break;
		case '#term_dps_en_fullscreen_btn_input_shell':
			params = '.dpsTbBtnFullscreen';
			break;
		case '#term_dps_en_zoom_btn_input_shell':
			params = '.dpsTbBtnZoom';
			break;
	}
	jQuery('#toolbarShell').find(params).each(function(){
		var element = noParent ? jQuery(this) : jQuery(this).parent();
		if(jQuery(buttonShell).find('input:radio:checked').val())
			element.show();
		else
			element.hide();
	});
}
function dpsChangeToolbarShadowVisible(val) {
	if(val)
		jQuery('.btnTbMain').addClass('shadowOn');
	else
		jQuery('.btnTbMain').removeClass('shadowOn');
}
function dpsChangeTooltipsOptionsVisible(val) {
	if(val) {
		jQuery('' +
		'#term_dps_toolbar_tootips_bg_color_shell, ' +
		'#term_dps_toolbar_tootips_txt_color_shell, ' +
		'#term_dps_toolbar_tootips_txt_font_shell, ' +
		'#term_dps_toolbar_tootips_txt_size_shell'
		).show(300);
	} else {
		jQuery('' +
		'#term_dps_toolbar_tootips_bg_color_shell, ' +
		'#term_dps_toolbar_tootips_txt_color_shell, ' +
		'#term_dps_toolbar_tootips_txt_font_shell, ' +
		'#term_dps_toolbar_tootips_txt_size_shell'
		).hide(300);
	}
}
