<?php
class bookViewDps extends viewDps {
	private $_usedBooks = array();
	private $_toolbarList = array();
	public function getBookHtml($params, $opts = array()) {
		$book = $this->getModel()->getById($params['id'], true, false, 'id', $opts);
		if(!empty($book)) {
			$book = $this->prepareBookToOut($book);
			$bookParamsDesc = $this->getModule()->getBookParamsDesc();
			foreach($bookParamsDesc as $k => $v) {
				if(isset($params[ $k ])) {
					$book->params[ $k ] = $params[ $k ];
				}
			}
			$book = $this->_prepareBookPages($book);
			$book = dispatcherDps::applyFilters('bookBeforeOut', $book);
			$this->_addUsedBook($book);
			$book->toolbar = $this->getToolbarDataByCode($book->params['toolbar_code']);
			if(isset($book->toolbar['css'])) {
				frameDps::_()->addStyle($book->params['toolbar_code'], $book->toolbar['css']);
			}
			$this->assign('book', $book);
			$this->assign('isAdmin', false);
			$this->assign('toolbarHtml', $this->getToolbarHtml($book));
			$this->assign('toolbarData', $book->toolbar);
			return parent::getInlineContent('bookDisplay');
		} else {
			$modelErrors = frameDps::_()->getModule('page')->getModel()->getErrors();
			if(empty($modelErrors)) {
				$modelErrors = $this->getModel()->getErrors();
			}
			if(empty($modelErrors))
				$modelErrors = __('Error display book', DPS_LANG_CODE);
			$this->assign('modelErrors', $modelErrors);
			return parent::getContent('bookDisplayErrors');
		}
	}
	private function _preparePageImgs($book, $page, $attachIds, $forceUseWpThumb = false) {
		$resizedUrl = '';
		$attachModel = $this->getModel('attach');
		$width = isset($book->params)
			? (isset($book->params['width_out']) ? (int) $book->params['width_out'] : (int) $book->params['width'])
			: 0;
		$height = isset($book->params)
			? (isset($book->params['height_out']) ? (int) $book->params['height_out'] : (int) $book->params['height'])
			: 0;
		$attachId = $attachIds[0];
		if($width && $height) {
			$width /= 2;	// As one page - is have full width/2 width
		//	$resizedUrl = $attachModel->getAttachment($attachId, $width, $height, false, $book->term_id);
		} else if($forceUseWpThumb) {
			$resizedUrl = wp_get_attachment_image_src($attachId, 'thumbnail');
			if($resizedUrl && $resizedUrl[0]) {
				$resizedUrl = $resizedUrl[0];
			}
		}
		if($resizedUrl && !strpos($page->post_content, $resizedUrl)) {
			$resizedUrl = utilsDps::checkAttachUrl($resizedUrl);
			preg_match('/src="([^"]*)"/i', $page->post_content, $imgSrcRes);
			if($imgSrcRes && $imgSrcRes[1]) {
				$page->post_content = str_replace($imgSrcRes[1], $resizedUrl, $page->post_content);
			}
		}
		$page->post_content = utilsDps::addDpsClassToPageImgs($page->post_content);
		return $page;
	}
	private function _prepareBookPages($book, $params = array()) {
		//$start = microtime(true);
		global $post;
		$needRedefinePost = (!empty($post) && is_object($post));
		if($needRedefinePost) {
			$tmpPost = clone($post);
		}
		if(!empty($book->pages)) {
			foreach($book->pages as $i => $page) {
				$attachIds = utilsDps::parseImgIds($page->post_content);
				$page->attach_sizes = array();
				if(!empty($attachIds)) {
					if($page->attach_id) {
						$forseUseWpThumb = isset($params['forceUseWpThumb']) && $params['forceUseWpThumb'] ? $params['forceUseWpThumb'] : false;
						$page = $this->_preparePageImgs($book, $page, $attachIds, $forseUseWpThumb);
					}
					foreach($attachIds as $aid) {
						if(!isset($page->attach_sizes[ $aid ])) {
							$fullImgData = wp_get_attachment_image_src($aid, 'full');
							$fullImgData[0] = utilsDps::checkAttachUrl($fullImgData[0]);
							$page->attach_sizes[ $aid ] = array('full' => $fullImgData[0]);
						}
					}
				}
				// We need this to prevent unwanted the_content hooks
				if($needRedefinePost) {
					$post = $page;
				}
				$page->post_content = apply_filters('the_content', $page->post_content);
				$page->post_content = str_replace(']]>', ']]&gt;', $page->post_content);
				$page->has_indent = isset($book->params['indent_text_only']) && $book->params['indent_text_only']
					? (bool)trim(strip_tags($page->post_content))
					: true;
				if(isset($params['includeEditLink']) && $params['includeEditLink']) {
					$page->edit_link = $this->getModule()->getLinkPageEdit($page->ID);
				}
			}
		}
		if($needRedefinePost) {
			$post = $tmpPost;
		}
		//echo '<br /><b>'. (microtime(true) - $start). '</b>';
		return $book;
	}
	private function _addUsedBook($book) {
		$this->_usedBooks[] = $book;
	}
	public function getUsedBooks() {
		return $this->_usedBooks;
	}
	public function getBookAdminFormInput($book, $params = array()) {
		frameDps::_()->getModule('templates')->loadCoreJs();
		frameDps::_()->getModule('templates')->loadCoreCss();
		$isAddForm = (isset($params['addForm']) && $params['addForm']);
		if($book && is_object($book))
			$bookParams = $this->getModel()->getBookParams($book->term_id);
		else
			$bookParams = array();
		if(!$isAddForm) {
			$toolbars = $this->getToolbarsList();
			foreach($toolbars as $tCode => $tData) {
				$toolbars[$tCode]['html'] = $this->getToolbarHtml($book, array('toolbar_code' => $tCode));
			}
			$this->assign('toolbars', $toolbars);
			$this->assign('presets', $this->getToolbarsPresets());
		}
		$this->assign('bookParams', $bookParams);
		$this->assign('bookParamsDesc', $this->getModule()->getBookParamsDesc());
		$this->assign('isAddForm', $isAddForm);

		return parent::display('bookAdminFormInput');
	}
	private function _getExportLinks($book) {
		$exportLinks = array(
			'html' => array('label' => __('HTML', DPS_LANG_CODE), 'link' => uriDps::mod('book', 'exportToHtml', array('id' => $book->term_id))),
		);
		if($this->getModule()->canUsePdfExport()) {
			$exportLinks['pdf'] = array('label' => __('PDF', DPS_LANG_CODE), 'link' => uriDps::mod('book', 'exportToPdf', array('id' => $book->term_id)));
		}
		return $exportLinks;
	}
	/**
	 * @param string $code Toolbar code
	 */
	public function getToolbarHtml($book, $isAdmin = false) {
		//$socLinks = false;
		$exportLinks = false;
		/*if(isset($book->params['social_links']) && !empty($book->params['social_links'])) {
			$socLinks = frameDps::_()->getModule('social_links')->prepareSocLinks($book->params['social_links']);
			if(!empty($socLinks)) {
				frameDps::_()->getModule('social_links')->loadAssets();
			}
		}*/
		if(isset($book->params['en_print_export_btn']) && !empty($book->params['en_print_export_btn']) || $isAdmin) {
			$exportLinks = $this->_getExportLinks($book);
		}
		$toolbarCode = $isAdmin ? $isAdmin['toolbar_code'] : $book->params['toolbar_code'];
		$this->assign('book', $book);
		$this->assign('toolbarData', $this->getToolbarDataByCode($toolbarCode));
		//$this->assign('socLinks', $socLinks);
		$this->assign('exportLinks', $exportLinks);
		$this->assign('presets', $this->getToolbarsPresets());
		$this->assign('isAdmin', $isAdmin ? true : false);
		$toolbarTpl = 'bookToolbar_'. $toolbarCode;
		return parent::getContent($toolbarTpl);
	}
	public function prepareBookToOut($book) {
		$book->params['area_width_out'] = $book->params['area_width']. $book->params['area_width_units'];
		$prepareSizeKeys = array('area_height', 'width', 'height');
		foreach($prepareSizeKeys as $key) {
			$book->params[ $key. '_out' ] = $this->sizeToPxPt($book->params[ $key ]);
		}
		return $book;
	}

	public function getToolbarsList() {
		if(empty($this->_toolbarList)) {
			$this->_toolbarList = array(
				'simple' => array('height' => 40, 'css' => $this->getModule()->getModPath(). 'css/bookTb_simple.css', 'switchResponsive' => 435),
				//'night' => array('height' => 40, 'css' => $this->getModule()->getModPath(). 'css/bookTb_night.css', 'switchResponsive' => 465),
			);
		}
		return $this->_toolbarList;
	}
	public function getToolbarsPresets() {
		if(empty($this->_toolbarPresets)) {
			$this->_toolbarPresets = array(
				'colorset' => array('bg_color' => '#404040', 'bg_opacity' => '1', 'color' => '#ADADAD', 'hover' => '#D6D6D6'),
				'borderset' => array('bg_color' => '#ffffff', 'bg_opacity' => '0', 'color' => '#4D3419', 'hover' => '#B9B0A3'),
			);
		}
		return $this->_toolbarPresets;
	}
	public function getToolbarDataByCode($code) {
		$this->getToolbarsList();
		return isset($this->_toolbarList[$code]) ? $this->_toolbarList[$code] : $this->_toolbarList['simple'];	// $this->_toolbarList['simple'] - just for now, it should be false there
	}
	public function displayBookPreview($d = array()) {
		$this->assign('book', $this->getModel()->getById($d['id'], false));
		$this->assign('id', $d['id']);
		$this->assign('bookHtml', $d['bookHtml']);
		parent::display('bookPreview');
	}
	public function displayEditBookFormButtons($tag) {
		$this->assign('previewUrl', $this->getModule()->getLinkPreviewBook(array('id' => $tag->term_id)));
		$this->assign('tag', $tag);
		$this->assign('shortcodeHtml', $this->getModule()->generateShortcodeHtml($tag->term_id));
		$this->assign('phpCodeHtml', $this->getModule()->generatePhpCodeHtml($tag->term_id));
		parent::display('bookFormButtons');
	}
	public function displayEditBookFormTabs($tag) {
		$tag->params = $this->getModel()->getBookParams($tag->term_id);
		$tag->pages = frameDps::_()->getModule('page')->getModel()->getListForBookByBookId($tag->term_id);
		$tag->pages = array_merge($tag->pages, frameDps::_()->getModule('pages_import')->getModel()->getImportedPages($tag->term_id));
		$tag->pages = frameDps::_()->getModule('book')->getModel()->resortPagesBySortOrder($tag->term_id, $tag->pages);
		$tag = $this->_prepareBookPages($tag, array('includeEditLink' => true, 'forceUseWpThumb' => true));
		frameDps::_()->addJSVar('admin.book.edit', 'dpsBook', (array) $tag);
		frameDps::_()->addJSVar('admin.book.edit', 'dpsBookPresets', $this->getToolbarsPresets());
		$this->assign('book', $tag);
		$this->assign('addBookPageUrl', $this->getModule()->getLinkAddPageForBook($tag->term_id));
		$this->assign('gdSupport', frameDps::_()->getModule('dps')->support('gd'));
		$this->assign('addTabs', dispatcherDps::applyFilters('bookAdminAddTabs', array(), $tag));
		parent::display('bookFormTabs');
	}
	public function getExportHtml($id, $params = array()) {
		$book = $this->getModel()->getById($id);
		if(!empty($book)) {
			$book = $this->prepareBookToOut($book);
			$book = $this->_prepareBookPages($book);
			$this->assign('book', $book);
			$this->assign('simple', (isset($params['simple']) ? $params['simple'] : false));
			$content = parent::getInlineContent('bookExportHtml');

			preg_match_all('/src="([^"]*)"/i', $content, $imgSrcRes);

			if($imgSrcRes && !empty($imgSrcRes[0]) && !empty($imgSrcRes[1])) {
				foreach($imgSrcRes[1] as $i => $url) {
					$url = trim($url);
					if(empty($url)) continue;
					$url = uriDps::normal($url);
					$url = str_replace('////', '//', $url);
					preg_match_all('/(?P<ATTACH>-[\d]+x[\d]+)\./', $url, $matches);

					if(!empty($matches)) {
						$matches['ATTACH'] = !is_array($matches['ATTACH']) ? array( $matches['ATTACH'] ) : $matches['ATTACH'];

						foreach($matches['ATTACH'] as $attach) {
							$fullUrl = str_replace($attach, '', $url);
							$fullImgSize = @getimagesize($fullUrl);	// try to check is file exist
							$url = $fullImgSize ? $fullUrl : $url;
						}
					}
					$content = str_replace($imgSrcRes[0][ $i ], 'src="'. str_replace(DPS_SITE_URL, '', $url). '"', $content);
				}
			}
			return $content;
		}
	}
}
