<?php
	$bookShellId = 'book_shell_'. esc_attr($this->book->term_id);
	$bookStageShellId = 'book_stage_'. esc_attr($this->book->term_id);
	$bookToolberShellId = 'book_toolbar_'. esc_attr($this->book->term_id);
	$bookId = 'book_'. esc_attr($this->book->term_id);
	$stageBgStyle = utilsDps::generateBgStyle(array(
		'type' => esc_attr($this->book->params['bg_type']),
		'color' => esc_attr(utilsDps::getRGBAColors($this->book->params['bg_color'], $this->book->params['bg_opacity'])),
		//'opacity' => $this->book->params['bg_opacity'],
		'img' => esc_attr($this->book->params['bg_img']),
		'img_pos' => isset($this->book->params['bg_img_pos']) ? esc_attr($this->book->params['bg_img_pos']) : 'center',
	));
	$pageBgStyle = utilsDps::generateBgStyle(array(
		'type' => esc_attr($this->book->params['page_bg_type']),
		'color' => esc_attr(utilsDps::getRGBAColors($this->book->params['page_bg_color'], $this->book->params['page_bg_opacity'])),
		//'opacity' => $this->book->params['page_bg_opacity'],
		'img' => esc_attr($this->book->params['page_bg_img']),
		'img_pos' => isset($this->book->params['page_img_pos']) ? esc_attr($this->book->params['page_img_pos']) : 'center',
	));
   $bookShellHeight = esc_attr((float)$this->book->params['area_height']) - esc_attr((float)$this->toolbarData['height']);
   $bookHeight = esc_attr($this->book->params['height']);
?>
<div class="dpsBookWrapper">
	<style type="text/css">
		#<?php echo $bookId?> {
			/*width: <?php echo $this->book->params['width_out']?>;
			height: <?php echo $this->book->params['height_out']?>;*/
			top: <?php echo ($bookShellHeight - $bookHeight) / 2?>px;
		}
		#<?php echo $bookStageShellId?> {
			width: <?php echo esc_attr($this->book->params['area_width_out'])?>;
			height: <?php echo esc_attr($this->book->params['area_height_out'])?>;
			<?php echo $stageBgStyle;?>;
		}
		#<?php echo $bookShellId?> {
			height: <?php echo $bookShellHeight?>px;
		}
		#<?php echo $bookId?> .page-main-content.dpsHasIndent {
			padding: <?php echo esc_attr((int)$this->book->params['page_content_indent'])?>px;
		}
		/*Pages will be just white for now*/
		#<?php echo $bookId?> .page {
			<?php echo $pageBgStyle?>;
			padding: 0 !important;
		}
	</style>
	<div id="<?php echo esc_attr($bookStageShellId)?>" class="dpsBookStageShell flipbook-viewport">
		<?php dispatcherDps::doAction('bookStartHtml', $this->book)?>
		<div id="<?php echo esc_attr($bookShellId)?>" class="dpsBookShell container">
			<div id="<?php echo esc_attr($bookId)?>" data-bookid="<?php echo esc_attr($this->book->term_id)?>" class="dpsBook flipbook"></div>
		</div>
		<div class="dpsTdShell" id="<?php echo esc_attr($bookToolberShellId)?>" data-bookid="<?php echo esc_attr($this->book->term_id)?>">
			<?php echo $this->toolbarHtml?>
		</div>
		<?php dispatcherDps::doAction('bookEndHtml', $this->book)?>
	</div>
</div>
