<?php
class optionsDps extends moduleDps {
	private $_tabs = array();
	
	public function init() {
		parent::init();
		$this->_checktDefOptions();
		dispatcherDps::addFilter('mainAdminTabs', array($this, 'addAdminTab'));
	}
	private function _getOptionsDefInited() {
		return (int)$this->get('options_initialized');
	}
	private function _setOptionsInited() {
		$this->getModel()->save('options_initialized', 1);
	}
	private function _checktDefOptions() {
		if(!$this->_getOptionsDefInited()) {
			$optsDesc = $this->getOptionsDesc();
			foreach($optsDesc as $key => $data) {
				if(isset($data['default']))
					$this->getModel()->save($key, $data['default']);
			}
			$this->_setOptionsInited();
		}
	}
    /**
     * This method provides fast access to options model method get
     * @see optionsModel::get($d)
     */
    public function get($code) {
        return $this->getModel()->get($code);
    }
	/**
     * This method provides fast access to options model method get
     * @see optionsModel::get($d)
     */
	public function isEmpty($code) {
		return $this->getModel()->isEmpty($code);
	}
	public function getAdminPage() {
		if(installerDps::isUsed()) {
			return $this->getView()->getAdminPage();
		} else {
			return frameDps::_()->getModule('supsystic_promo')->showWelcomePage();
		}
	}
	public function addAdminTab($tabs) {
		/*$tabs['settings'] = array(
			'label' => __('Settings', DPS_LANG_CODE), 'callback' => array($this, 'getSettingsTabContent'), 'fa_icon' => 'fa-gear', 'sort_order' => 30,
		);*/
		return $tabs;
	}
	public function getSettingsTabContent() {
		return $this->getView()->getSettingsTabContent();
	}
	public function getTabs() {
		if(empty($this->_tabs)) {
			$this->_tabs = dispatcherDps::applyFilters('mainAdminTabs', array(
				//'main_page' => array('label' => __('Main Page', DPS_LANG_CODE), 'callback' => array($this, 'getTabContent'), 'wp_icon' => 'dashicons-admin-home', 'sort_order' => 0),
			));
			foreach($this->_tabs as $tabKey => $tab) {
				if(!isset($this->_tabs[ $tabKey ]['url'])) {
					$this->_tabs[ $tabKey ]['url'] = $this->getTabUrl( $tabKey );
				}
			}
			uasort($this->_tabs, array($this, 'sortTabsClb'));
		}
		return $this->_tabs;
	}
	public function sortTabsClb($a, $b) {
		if(isset($a['sort_order']) && isset($b['sort_order'])) {
			if($a['sort_order'] > $b['sort_order'])
				return 1;
			if($a['sort_order'] < $b['sort_order'])
				return -1;
		}
		return 0;
	}
	public function getTab($tabKey) {
		$this->getTabs();
		return isset($this->_tabs[ $tabKey ]) ? $this->_tabs[ $tabKey ] : false;
	}
	public function getTabContent() {
		return $this->getView()->getTabContent();
	}
	public function getActiveTab() {
		$reqTab = reqDps::getVar('tab');
		return empty($reqTab) ? 'overview' : $reqTab;
	}
	public function getTabUrl($tab = '') {
		static $mainUrl;
		if(empty($mainUrl)) {
			$mainUrl = frameDps::_()->getModule('adminmenu')->getMainLink();
		}
		return empty($tab) ? $mainUrl : $mainUrl. '&tab='. $tab;
	}
	public function getOptionsDesc() {
		if(empty($this->_optionsDesc)) {
			$this->_optionsDesc = array(
				'def_area_width' => array('label' => __('Default Area Width'), 'type' => 'text', 'default' => '100', DPS_LANG_CODE),
				'def_area_height' => array('label' => __('Default Area Height'), 'type' => 'text', 'default' => '600', DPS_LANG_CODE),
				'def_width' => array('label' => __('Default Publication Width'), 'type' => 'text', 'default' => '800', DPS_LANG_CODE),
				'def_height' => array('label' => __('Default Publication Height'), 'type' => 'text', 'default' => '400', DPS_LANG_CODE),
			);
		}
		return $this->_optionsDesc;
	}
}