<?php
class pages_importViewDps extends viewDps {
	public function getAdminTabHtml($book) {
		$bookModule = frameDps::_()->getModule('book');
		$bookParamsDesc = $bookModule->getBookParamsDesc();
		$bookParams = $book && is_object($book) ? $bookModule->getModel()->getBookParams($book->term_id) : array();
		$bookParamsList = array();

		foreach($bookParamsDesc as $key => $param) {
			if(isset($param['tab']) && $param['tab'] == 'pages_import') {
				$bookParamsList[$key] = $param;
				$bookParamsList[$key]['params'] = !empty($bookParamsList[$key]['params']) ? $bookParamsList[$key]['params'] : array();
				$bookParamsList[$key]['params']['value'] = !empty($bookParams[$key]) ? esc_attr($bookParams[$key]) : esc_attr($bookParamsList[$key]['params']['value']);

				if(!empty($bookParamsList[$key]['promo'])) continue;

				$postType = str_replace('import_', '', $key);
				$function = $postType == 'page' ? 'get_pages' : 'get_posts';
				$posts = $function(array(
					'post_type' => $postType,
					'post_status' => 'publish',
					'numberposts' => -1,
					'orderby' => 'post_title',
					'order' => 'ASC',
					'suppress_filters' => true,
				));

				if(!empty($posts)) {
					$bookParamsList[$key]['params']['options'] = array();
					foreach($posts as $p) {
						$bookParamsList[$key]['params']['options'][$p->ID] = $p->post_title;
					}
				}
			}
		}

		$this->assign('bookParams', $bookParamsList);

		return parent::getContent('importPagesAdminTab');
	}

	public function formatImportedPostPages($page, $bookParams){
        $this->assign('page', $page);
        $this->assign('bookParams', $bookParams);

        return parent::getContent('postPage');
    }

    public function formatImportedProductPages($page, $bookParams) {
        $this->assign('page', $page);
        $this->assign('bookParams', $bookParams);

        return parent::getContent('productPage');
    }
}
