<?php
class templatesDps extends moduleDps {
    protected $_styles = array();
	public function __construct($d) {
		parent::__construct($d);
	}
	public function init() {
		if (is_admin()) {
			$isAdminPlugOptsPage = frameDps::_()->isAdminPlugOptsPage();
			//$isPluginsPage = utilsDps::isPluginsPage();
			$isBooksPage = frameDps::_()->getModule('pages')->isAdminBooksPage();
			$isPagePage = frameDps::_()->getModule('pages')->isAdminPagesPage();

			if($isAdminPlugOptsPage || /*$isPluginsPage ||*/ $isBooksPage || $isPagePage) {
				$this->loadCoreJs();
				$this->loadAdminCoreJs();
				$this->loadCoreCss();
				$this->loadChosenSelects();
				$this->loadFontAwesome();

        frameDps::_()->addScript('dpsAcPromoScript', DPS_JS_PATH. 'acPromoScript.js');
        frameDps::_()->addStyle('dpsAcPromoStyle', DPS_CSS_PATH. 'acPromoStyle.css');

				frameDps::_()->addScript('adminOptionsDps', DPS_JS_PATH. 'admin.options.js');
				add_action('admin_enqueue_scripts', array($this, 'loadMediaScripts'));
				if($isBooksPage) {
					frameDps::_()->getModule('book')->loadAdminAssets();
				}
				if($isPagePage) {
					frameDps::_()->getModule('page')->loadAdminAssets();
				}
			}
			// Some common styles - that need to be on all admin pages - be careful with them
			frameDps::_()->addStyle('supsystic-for-all-admin'. DPS_CODE, DPS_CSS_PATH. 'supsystic-for-all-admin.css');
		}
		parent::init();
	}
	public function loadMediaScripts() {
		wp_enqueue_media();
	}
	public function loadAdminCoreJs() {
		frameDps::_()->addScript('jquery-ui-dialog');
		frameDps::_()->addScript('jquery-ui-slider');
		frameDps::_()->addScript('wp-color-picker');
		frameDps::_()->addScript('icheck', DPS_JS_PATH. 'icheck.min.js');
		$this->loadTooltipster();
	}
	public function loadCoreJs() {
		frameDps::_()->addScript('jquery-ui-dialog');
		frameDps::_()->addScript('jquery');
		frameDps::_()->addScript('commonDps', DPS_JS_PATH. 'common.js');
		frameDps::_()->addScript('coreDps', DPS_JS_PATH. 'core.js');

		$ajaxurl = admin_url('admin-ajax.php');
		$jsData = array(
			'siteUrl'					=> DPS_SITE_URL,
			'DPS_CODE'				=> DPS_CODE,
			'imgPath'					=> DPS_IMG_PATH,
			'jsPath'					=> DPS_JS_PATH,
			'cssPath'					=> DPS_CSS_PATH,
			'loader'					=> DPS_LOADER_IMG,
			'ajaxurl'					=> $ajaxurl,
			'animationSpeed'			=> frameDps::_()->getModule('options')->get('js_animation_speed'),
			'DPS_BOOK'					=> DPS_BOOK,
			'DPS_PAGE'					=> DPS_PAGE,
			'bookEditUrlPattern'		=> frameDps::_()->getModule('book')->getLinkBookEdit('DYNAMIC_BOOK_ID')
		);
		if ( is_admin() ) {
			$jsData['isPro'] = frameDps::_()->getModule('supsystic_promo')->isPro();
      $show = true;
      $acRemind = get_option('dps_ac_remind', false);
      if (!empty($acRemind)) {
        $currentDate = date('Y-m-d h:i:s');
        if ($currentDate > $acRemind) {
          $show = true;
        } else {
          $show = false;
        }
      }
      $acSubscribe = get_option('dps_ac_subscribe', false);
      if (!empty($acSubscribe)) {
        $show = false;
      }
      $acDisabled = get_option('dps_ac_disabled', false);
      if (!empty($acDisabled)) {
        $show = false;
      }
      $jsData['dpsAcShow'] = $show;
		}
		$jsData = dispatcherDps::applyFilters('jsInitVariables', $jsData);
		frameDps::_()->addJSVar('coreDps', 'DPS_DATA', $jsData);
	}
	public function loadCoreCss() {
		$this->_styles = array(
			'styleDps'			=> array('path' => DPS_CSS_PATH. 'style.css', 'for' => 'admin'),
			'adminStylesDps'	=> array('path' => DPS_CSS_PATH. 'adminStyles.css', 'for' => 'admin'),
			'supsystic-uiDps'	=> array('path' => DPS_CSS_PATH. 'supsystic-ui.css', 'for' => 'admin'),
			'icheck'			=> array('path' => DPS_CSS_PATH. 'jquery.icheck.css', 'for' => 'admin'),
			'dashicons'			=> array('for' => 'admin'),
			'wp-color-picker'	=> array('for' => 'admin'),
		);
		foreach($this->_styles as $s => $sInfo) {
			if(!empty($sInfo['path'])) {
				frameDps::_()->addStyle($s, $sInfo['path']);
			} else {
				frameDps::_()->addStyle($s);
			}
		}
	}
	public function loadFontAwesome() {
		frameDps::_()->addStyle('font-awesomeDps', DPS_CSS_PATH. 'font-awesome.min.css');
	}
	public function loadChosenSelects() {
		frameDps::_()->addStyle('jquery.chosen', DPS_CSS_PATH. 'chosen.min.css');
		frameDps::_()->addScript('jquery.chosen', DPS_JS_PATH. 'chosen.jquery.min.js');
	}
	public function loadTooltipster() {
		frameDps::_()->addScript('tooltipster', DPS_JS_PATH. 'jquery.tooltipster.min.js');
		frameDps::_()->addStyle('tooltipster', DPS_CSS_PATH. 'tooltipster.css');
	}
	public function loadSlimscroll() {
		// not in use
		frameDps::_()->addScript('jquery.slimscroll', DPS_JS_PATH . 'jquery.slimscroll.js');
	}
	public function loadJqueryUi() {
		static $loaded = false;
		if(!$loaded) {
			frameDps::_()->addStyle('jquery-ui', DPS_CSS_PATH. 'jquery-ui.min.css');
			frameDps::_()->addStyle('jquery-ui.structure', DPS_CSS_PATH. 'jquery-ui.structure.min.css');
			frameDps::_()->addStyle('jquery-ui.theme', DPS_CSS_PATH. 'jquery-ui.theme.min.css');
			frameDps::_()->addStyle('jquery-slider', DPS_CSS_PATH. 'jquery-slider.css');
			$loaded = true;
		}
	}
	public function loadSupTablesUi() {
		static $loaded = false;
		if(!$loaded) {
      frameDps::_()->addStyle('supTablesUi', DPS_CSS_PATH . 'suptablesui.min.css');
			$loaded = true;
		}
	}
	public function loadGoogleFont( $font ) {
		static $loaded = array();
		if(!isset($loaded[ $font ])) {
			frameDps::_()->addStyle('google.font.'. str_replace(array(' '), '-', $font), 'https://fonts.googleapis.com/css?family='. urlencode($font));
			$loaded[ $font ] = 1;
		}
	}
}
